using System;
using System.Windows.Forms;

using Emgu.CV;
using Emgu.CV.GPU;
using Emgu.CV.Structure;
using Emgu.CV.UI;

namespace TestProject
{
    /// <summary>
    /// α׷
    /// </summary>
    static class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region α׷ ϱ - Main()

        /// <summary>
        /// α׷ ϱ
        /// </summary>
        [STAThread]
        private static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            long matchTime;

            using(Image<Gray, Byte> modelImage = new Image<Gray, byte>("box.png"))
            {
                using(Image<Gray, Byte> sourceImage = new Image<Gray, byte>("box_in_scene.png"))
                {
                    Image<Bgr, byte> resultImage = MatchHelper.Draw(modelImage, sourceImage, out matchTime);

                    ImageViewer.Show
                    (
                        resultImage,
                        string.Format
                        (
                            "{0}  ġ  Ǵ : {1} и",
                            GpuInvoke.HasCuda ? "GPU" : "CPU",
                            matchTime
                        )
                    );
                }
            }
        }

        #endregion
    }
}